/*->c.main */



#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "transform.h"
#include "process.h"

#include "wos.h"
#include "err.h"
#include "task.h"
#include "poll.h"
#include "temp.h"
#include "scrap.h"
#include "fsx.h"
#include "conf.h"
#include "etc.h"
#include "flex.h"
#include "sp.h"
#include "deb.h"
#include "appinfo.h"
#include "appreg.h"
#include "mlo.h"
#include "osunits.h"
#include "oshelp.h"
#include "colour.h"
#include "xmath.h"


#include "resource.h"


#include "constants.h"

#include "reslink.h"

#include "veclib.h"
#include "imlib.h"
#include "file.h"
#include "fit.h"
#include "tracecode.h"

#include "main.h"



int    version=220;
int    compatability=0;
char * datestring="(04-February-18)";

int    mainhandle;
int    bitmaphandle;
int    vectorhandle;

void terminate(void)
{
 event(EVENT_ENDPROGRAM,NULL,0);
 flex_finit();
 exit(0);
}




static os_error * terminatemessage(wimp_msgstr * msg,int * ack)
{
 terminate();
 USE(msg);
 USE(ack);
 return(NULL);
}

int unsaved(void)
{

 return(0);
}


/* return 1 if not to quit */

static int termnok(void)
{
 int n=unsaved();
 int code;

 if(n)
 {
  if(n==1) confirmparent(0,CONDC,&code,"{FS10}");  /* files edited but not saved */
  else     confirmparent(0,CONDC,&code,"%d {FS09}",n);

  if(code!=1) return(1);
 }

 return(0);
}


/* set ack to 1 if you want to stop the quit sequence */
/*
static os_error * prequithandler(int userhandle,int * ack,int prequit) 
{
 if(prequit==1)
 {
  if(unsaved()) *ack=1;
 }
 else
 {
  if(termnok()) *ack=1;
  else
  {

  
  }
 }
 return(NULL);

 USE(userhandle);
}

*/

static os_error * addmessages(void)
{
 os_error * err;

          err=addmessage(terminatemessage,wimp_MCLOSEDOWN);
// if(!err) err=addprequit(prequithandler,0);

 return(err);
}






static os_error * appregevent(int handle,int event)
{
 os_error * err;

 err=NULL;

 switch(event)
 {

 case APPREGDOC:
                helptopic(mainhandle,"<HKEY_LOCAL_MACHINE\\Software\\Microsoft\\Windows\\CurrentVersion\\App Paths\\DPTrace.exe\\Path>\\Trace.chm::/registration.htm>");
                break;

 }

 return(err);

 USE(handle);
}





static os_error * helpdecode(int * menu,int window)
{
 os_error * err;

 err=NULL;

 switch(menu[0])
 {

  case         ID_HELP_REGISTER:
                                err=appregwindow(window);
                                break;

  case            ID_HELP_ABOUT:
                                infowindow(window,version,datestring);
                                break;

  case    ID_HELP_CONTENTSINDEX:
                                helptopic(window,"<HKEY_LOCAL_MACHINE\\Software\\Microsoft\\Windows\\CurrentVersion\\App Paths\\DPTrace.exe\\Path>\\Trace.chm>");
                                break;


 }

 return(err);
}


static os_error * filedecode(int * menu,int window)
{
 os_error * err;

 err=NULL;

 switch(menu[0])
 {

 case ID_FILE_EXIT:
                   pollquit(0);
                   break;


 case ID_FILE_OPENBITMAP:
                         err=loadbitmap(window);
                         break;


 case ID_FILE_SAVEVECTORAS:
                           err=savevector(window);
                           break;



 }


 return(err);
}



static os_error * tracedecode(int * menu,int window)
{
 os_error * err;

 err=NULL;

 switch(menu[0])
 {
  case    ID_TRACE_DOTRACE:
                           err=dofit();
                           break;

  case  ID_TRACE_IMAGEINFO:
                           err=imageinfowindow(window);
                           break;

  case       ID_TRACE_ZOOM:
                           err=zoombox(window);
                           break;

  case   ID_TRACE_SETTINGS:
                           err=settings(window);
                           break;
 }

 return(err);
}





/* open info window and pass back pointer */

os_error * maindynamic(int * menu,char * handle,int window)
{
 os_error * err;

 err=NULL;

 USE(menu);
 USE(handle);
 USE(window);
 return(err);
}




os_error * maindecode(int * menu,int window)
{
 os_error * err;

 err=NULL;

 switch(menu[0])
 {

   case 0:
         err=filedecode(menu+1,window);
         break;

  case 1:
         err=tracedecode(menu+1,window);
         break;

  case 2:
         err=helpdecode(menu+1,window);
         break;

 }
         
 return(err);

 USE(window);
}




static os_error * mainclose(int handle,int userhandle)
{
 pollquit(0);
 return(NULL);
 USE(handle);
 USE(userhandle);
}


static int splitfraction=0x8000;

#define XPIXBORDER 2
#define YPIXBORDER 2

#define SPLITGAP 2

static os_error * mainopen(int handle,int userhandle,wimp_openstr * open)
{
 os_error   * err;
 wimp_openstr o;
 windowstr    window;
 int          x0;
 int          x1;
 int          y0;
 int          y1;


 x0=xos2pix(open->box.x0);
 x1=xos2pix(open->box.x1);
 y1=yos2pix(open->box.y1); 
 y0=yos2pix(open->box.y0);

 getw(bitmaphandle,&window);

 o.w=bitmaphandle;
 o.box.x0=xpix2os(x0);
 o.box.y0=ypix2os(y0);   
 o.box.x1=xpix2os(x0+((x1-x0)*splitfraction)/0x10000-SPLITGAP);
 o.box.y1=ypix2os(y1);
 o.x=window.scx;       
 o.y=window.scy;
               
 o.behind=-3; //open->behind;

 err=wimp_open_wind_ex(&o);

 getw(vectorhandle,&window);

 o.w=vectorhandle;
 o.box.x0=xpix2os(x0+((x1-x0)*splitfraction)/0x10000+SPLITGAP);
 o.box.y0=ypix2os(y0);   
 o.box.x1=xpix2os(x1);
 o.box.y1=ypix2os(y1);
 o.x=window.scx;       
 o.y=window.scy;
               
 o.behind=-3; //open->behind;

 err=wimp_open_wind_ex(&o);


 return(err);
 USE(handle);
 USE(userhandle);
}




static os_error * mainsetcursor(int handle,int userhandle,wimp_mousestr * m,int * set)
{
 os_error * err;

 err=NULL;

 if(m->w==handle)
 {
  err=changepointer(ICONPOINTER,NULL,"splith");
  *set=1;
 }

 return(err);
 USE(m);
 USE(userhandle);
 USE(handle);
}



static os_error * maindrag(int handle,int userhandle,wimp_box * box)
{
 windowstr    window;
 wimp_openstr open;

 getw(handle,&window);

 splitfraction=scale(box->x0-window.x0,0x10000,window.x1-window.x0);
 if(splitfraction<(0x10000/20)) splitfraction=0x10000/20;
 if(splitfraction>(0x10000*19)/20) splitfraction=(0x10000*19)/20;

 getos(&window,&open);
 mainopen(handle,userhandle,&open);

 return(NULL);
}





static os_error * mainicon(int handle,int userhandle,wimp_mousestr * m)
{
 os_error     * err;
 wimp_dragstr   d;
 windowstr      window;

 err=NULL;

 if(m->bbits==0x40)
 {
  getw(handle,&window);
  
  d.window=handle;
  d.type=wimp_USER_SPLITTER;
  d.box.x0=m->x;
  d.box.x1=m->x;
  d.box.y0=window.y0;
  d.box.y1=window.y1;

  wimp_drag_box(&d);
  startdrag(handle,userhandle,maindrag);
 }

 return(err);
}


os_error * bitmapredrawsub(wimp_redrawstr * redrawstr,int more,int userhandle)
{
 os_error * err;
 int        ox;
 int        oy;

 err=NULL;

 while(more)
 {
  ox=redrawstr->box.x0-redrawstr->scx;
  oy=redrawstr->box.y1-redrawstr->scy;

  if(framebase)
  {
   impaintos(&framebase->frame[0],ox,oy-scale(sposy,zoommul,zoomdiv),scale(sposx,zoommul,zoomdiv),-scale(sposy,zoommul,zoomdiv));
  }

  wimp_get_rectangle(redrawstr,&more);
 }

 return(err);

 USE(userhandle);
}





os_error * bitmapredraw(int handle,int userhandle)
{
 os_error       * err;
 wimp_redrawstr   redrawstr;
 int              more;

 redrawstr.w=handle;

          err=wimp_redraw_wind(&redrawstr,&more);
 if(!err) err=bitmapredrawsub(&redrawstr,more,userhandle);

 return(err);
}







os_error * vectorredrawsub(wimp_redrawstr * redrawstr,int more,vechandle vhandle,int index)
{
 os_error * err;
 int        ox;
 int        oy;

 err=NULL;

 while(more)
 {
  ox=redrawstr->box.x0-redrawstr->scx;
  oy=redrawstr->box.y1-redrawstr->scy;

  if(vhandle)
  {
   vecpaint(ox,oy-scale(sposy,zoommul,zoomdiv),scale(sposx,zoommul,zoomdiv),scale(sposy,zoommul,zoomdiv),vhandle,index);
  }

  wimp_get_rectangle(redrawstr,&more);
 }

 return(err);
}





os_error * vectorredraw(int handle,int userhandle)
{
 os_error       * err;
 wimp_redrawstr   redrawstr;
 int              more;

 redrawstr.w=handle;

          err=wimp_redraw_wind(&redrawstr,&more);
 if(!err) err=vectorredrawsub(&redrawstr,more,vhandle,0);

 return(err);
 USE(userhandle);
}


os_error * vectorupdate(vechandle vhandle,int index)
{
 os_error       * err;
 wimp_redrawstr   redrawstr;
 int              more;
 windowstr        window;


 getw(vectorhandle,&window);

 redrawstr.w=vectorhandle;
 redrawstr.box.x0=window.x0-window.bx;
 redrawstr.box.x1=window.x1-window.bx;
 redrawstr.box.y0=window.y0-window.by; 
 redrawstr.box.y1=window.y1-window.by;   

          err=wimp_update_wind(&redrawstr,&more);
 if(!err) err=vectorredrawsub(&redrawstr,more,vhandle,index);

 return(err);
}





static os_error * openmainwindow(void)
{
 os_error    * err;
 wimp_wstate   wstate;


 err=createwindow(TMAIN,&mainhandle);
 if(!err)
 {
           err=createwindowparent(TBITMAP,&bitmaphandle,mainhandle);
  if(!err) err=err=createwindowparent(TVECTOR,&vectorhandle,mainhandle);


  wimp_setwindowbackground(vectorhandle,CCWIMPBASE+WIMPWHITE);
  wimp_setwindowflags(vectorhandle,WINDOWFIXED,0);
  addredrawevent(vectorredraw,vectorhandle,0);
  adddataload(vectorhandle,0,loadbitmapv);
  adddataloadpost(vectorhandle,0,loadbitmappostv);
  adddataloadtype(vectorhandle,0,loadbitmaptypev);

  wimp_setwindowbackground(bitmaphandle,CCWIMPBASE+WIMPWHITE);
  wimp_setwindowflags(bitmaphandle,WINDOWFIXED,0);
  addredrawevent(bitmapredraw,bitmaphandle,0);
  adddataload(bitmaphandle,0,loadbitmapv);
  adddataloadpost(bitmaphandle,0,loadbitmappostv);
  adddataloadtype(bitmaphandle,0,loadbitmaptypev);


  addwindowmenu(mainhandle,MMAIN);

  addcloseevent(mainclose,mainhandle,0);
  addopenevent(mainopen,mainhandle,0);

  adddataload(mainhandle,0,loadbitmapv);
  adddataloadpost(mainhandle,0,loadbitmappostv);
  adddataloadtype(mainhandle,0,loadbitmaptypev);

  addclickevent(mainicon,mainhandle,0);
  addsetcursorevent(mainsetcursor,mainhandle,0);


  popup(mainhandle,0);
  wimp_get_wind_state(mainhandle,&wstate);
  mainopen(mainhandle,0,&wstate.o);

  setactive(mainhandle);
 }

 return(err);
}










static void crashcleanup(void)
{
 flex_finit();
}



static int productcodes[]=
{
 APPREGTRACECODE,
 APPREGTRACESLCODE,
 APPREGLASTCODE
};


int main(int argc,char * argv[])
{ 
 os_error * err;

 setlocale(LC_ALL,".1252");

 err=inittask("Trace","Trace","!Trace",NULL,NULL,NULL);


 if(err)
 {
  report(err);
  exit(0);
 }


// debugenable(crashcleanup);

 wimpt_setcrash(crashcleanup);


 if(!err) err=resinit(NULL);
 if(!err) err=addmessages();

 fitinit();

 event(EVENT_RUNPROGRAM,NULL,0);

          err=openmainwindow();

 if(err)
 {
  report(err);
  terminate();
 }

 runtask();

 return(0);

 
 USE(argc);
 USE(argv[0]);
}

