/*->c.reslink */



#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "wos.h"


#include "mlo.h"
#include "transform.h"
#include "poll.h"

#include "err.h"
#include "temp.h"
#include "filetype.h"
#include "xhelp.h"


#include "constants.h"


#include "veclib.h"
#include "main.h"

#include "reslink.h"



static errtag errortable[]=
{
 ENOTTYPE,"{ENOTTYPE}",
 EREPDEC,"{EREPDEC}",
 EREPNEG,"{EREPNEG}",
 EBADVAL,"{EBADVAL}",

 EBU,"{EBU}",
 EBD,"{EBD}",
 EBB,"{EBB}",
 EID,"{EID}",
 EPCD,"{EPCD}",
 EPCL,"{EPCL}", 
 ECR,"{ECR}",


 EBADBITS,"{EBADBITS}",

 EC00,"{EC00}",
 EC01,"{EC01}",
 EC02,"{EC02}",

 ENOIMAGE,"{ENOIMAGE}",
 ENOVECTOR,"{ENOVECTOR}",

 EVM00,"{EVM00}",

 ES00,"{ES00}",

 EMODE,"{EMODE}",

 ED00,"{ED00}",

 EICO0,"{EICO0}",

 ELAST ,""
};


static errlink errorlink;

static templates temptable[]=
{
 TCONF,0,0,"Confirm",
 TINFO,1,0,"Info",

 TMAIN,0,0,"main",
 TBITMAP,0,0,"bitmap",
 TVECTOR,0,0,"vector",
 TIMAGEINFO,0,0,"IMAGEINFO",
 TZOOM,0,0,"ZOOM",
 TSETTINGS,0,0,"Settings",

 TLAST,0,0,""
};


static templink templatelink;

/*
typedef struct menustr
{
 int            menuno;
 char         * menuname;
 int          * menuptr;
 int            flags;
 int            parent;
 int            entryinparent;
 menudecodefn   decode;
 menudynamicfn  dynamic;
} menustr;

*/




static menustr menutable[]=
{
 MMAIN,   "Main",    NULL,  0,  0,  0,  0,   0, maindecode,maindynamic,
 MFILE,   NULL,      NULL,  0,  0,MMAIN,0,   0, NULL,      NULL,
 MTRACE,  NULL,      NULL,  0,  0,MMAIN,1,   0, NULL,      NULL,
 MHELP,   NULL,      NULL,  0,  0,MMAIN,2,   0, NULL,      NULL,

 MLAST,   NULL,      NULL,  0,  0,  0,  0,   0, NULL,      NULL,

};


static menulink mlink;





static filetypelink filetypelink;


static filetypetag filetypetable[]=
{
 BMP,"bmp","Bitmap (*.bmp)",
 DATA,NULL,"Data (*.dat)",
 EMFTYPE,"emf","Enhanced metafile (*.emf)",
 WMFTYPE,"wmf","Windows metafile (*.wmf)",
 PMFTYPE,"wmf","Placeable metafile (*.wmf)",
 FTDEFLT,"dat","Data (*.dat)",

 FTLAST,NULL,NULL,
};





os_error * resinit(char * resources)
{
 os_error * err;

          err=adderrortable(errortable,&errorlink);
 if(!err) err=addtemplates(resources,"Templates",temptable,&templatelink);
 if(!err) err=addmenus(NULL,NULL,menutable,&mlink);
 if(!err) err=addfiletypetable(filetypetable,&filetypelink);
 if(!err) err=addhelp(NULL,"IntHelp.txt");

 return(err);
}

