/*->c.trace */


#include "stdafx.h"
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <signal.h>
#include <ctype.h>
#include <time.h>
#include <locale.h>
//#include <math.h>


#include "os.h"
#include "wimp.h"
#include "sprite.h"
#include "wimpt.h"
#include "bbc.h"
#include "akbd.h"
#include "werr.h"
#include "flex.h"
#include "hourglass.h"
#include "err.h"
#include "transform.h"
#include "process.h"

#include "deb.h"
#include "wos.h"


#include "fit.h"
#include "veclib.h"
#include "imlib.h"
#include "file.h"
#include "main.h"
#include "reslink.h"

#include "tracecode.h"



/****************************************************************************/

char * spseenmask=NULL;


os_error * initseenmask(void)
{
 int seensize;
 int * i;
 os_error * err;

 seensize=(spx*spy);
 seensize=(seensize>>3)+((seensize & 7)>0);
 seensize=(seensize>>2)+((seensize & 3)>0);

 err=flex_alloc((flex_ptr)&spseenmask,seensize*4);

 if(!err)
 {
  i=(int *)spseenmask;
  while(seensize--) *i++=0;
 }

 return(err);
}


void trashseenmask(void)
{
 flex_free((flex_ptr)&spseenmask);
}


int testseenmask(int x,int y)
{
 int bit=x+y*spx;
 int byte=*(spseenmask+(bit>>3));
 bit=bit & 0x7;
 return((byte>>bit) & 0x1);
}


void setseenmask(int x,int y)
{
 int     bit=x+y*spx;
 char *  byte=(spseenmask+(bit>>3));
 bit=bit & 0x7;
 *byte|=(0x1 << bit);
}


int pixelmxys(int x,int y)
{            
 if(x<0 || x>=spx || y<0 || y>=spy) return(-1);
 if(testseenmask(x,y)) return(-1);
 return(pixelxy(x,y));
}

int pixelmxy(int x,int y)
{
 int code;

/* dprintf(5,"before");  */
 code=pixelmxys(x,y);
/* dprintf(5,"code=%d",code);  */

 return(code);
}



/*****************************************************************************/


#define INITPSIZE 2560
#define STEPPSIZE 2560



       ipoint2 * pointstore=NULL;
static int       npoints;
static int       maxpoints;


static os_error * initpointstore(void)
{
 os_error * err;

 err=flex_alloc((flex_ptr)&pointstore,INITPSIZE);
 if(!err)
 {
  npoints=0;
  maxpoints=INITPSIZE/(sizeof(ipoint2))-2;
 }

 return(err);
}


static void clearpointstore(void)
{
 npoints=0;
}



static void trashpointstore(void)
{
 flex_free((flex_ptr)&pointstore);
}



static os_error * addpoint(int x,int y)
{
 os_error * err;

 err=NULL;

 pointstore[npoints].x=x;
 pointstore[npoints].y=y;
 npoints++;

 if(npoints>=maxpoints)
 {
  maxpoints+=STEPPSIZE/sizeof(ipoint2);
  err=flex_extend((flex_ptr)&pointstore,maxpoints*sizeof(ipoint2));
 } 

 return(err);
}





/*****************************************************************************/

typedef struct stackitem
{
 int x;
 int y;
 int llim;
 int rlim;
 int dir;
} stackitem;

#define STACKLIM 1024


static stackitem * stack;
static stackitem * stkptr;
static stackitem * stklt;


static void popstack(stackitem * item)
{
 if(stkptr==stack)
 {
  item->x=item->y=-1;
 }
 else
 {
  stkptr--;
  *item=*stkptr;
 }
}



static os_error * pushstack(int x,int y,int * stackx,int startx,int dir)
{
 os_error * err;

 err=NULL;

 if(stkptr==stklt)
 {
  err=flex_extend((flex_ptr)&stack,(stklt-stack+STACKLIM)*sizeof(stackitem));
  if(!err)
  {
   stklt+=STACKLIM;
  }
 }

 if(!err)
 {
  stkptr->x=*stackx;
  stkptr->y=y;
  stkptr->llim=startx;
  stkptr->rlim=x;
  stkptr->dir=dir;
  stkptr++;
  *stackx=-1;
 }

 return(err);
}


static os_error * checkgap(int x,int y,int * stackx,int startx,int target,int dir)
{
 os_error * err;

 err=NULL;

 if(*stackx==-1)
 {
/*  if(pixelmxy(x+1,y)==target) *stackx=x;  */
  if(pixelmxy(x,y)==target)   *stackx=x;
/*  if(pixelmxy(x-1,y)==target) *stackx=x;  */
 }
 else
 {
  if(pixelmxy(x,y)!=target) err=pushstack(x,y,stackx,startx,dir);
 }

 return(err);
}


static os_error * fillline(stackitem * item,int target)
{
 int startup=-1;
 int startdown=-1;
 int startx;
 int x=item->x;
 int y=item->y;
 int dir=item->dir;
 int llim=item->llim;
 int rlim=item->rlim;
 os_error * err;

 while(pixelmxy(x,y)==target) x--;
 x++;
 startx=x;

 err=NULL;

 while(pixelmxy(x,y)==target)
 {
  setseenmask(x,y);

  if(dir & 0x2)      /* going down */
  {
   err=checkgap(x,y-1,&startdown,startx,target,2);
   if(err) break;
   if(!(x>=llim && x<=rlim))
   {
    checkgap(x,y+1,&startup,startx,target,1);
    if(err) break;
   }
  }

  if(dir & 0x1)      /* going up */
  {
   err=checkgap(x,y+1,&startup,startx,target,1);
   if(err) break;
   if(!(x>=llim && x<=rlim))
   {
    checkgap(x,y-1,&startdown,startx,target,2);
    if(err) break;
   }
  }
  x++;
 }

 if(!err)
 {
  if(startup!=-1)   err=pushstack(x /* -1 */,y+1,&startup,startx,1);
  if(!err)
  {
   if(startdown!=-1) err=pushstack(x /* -1 */,y-1,&startdown,startx,2);
  }
 }

 return(err);
}



/* return 1 if fails, else 0 */

static os_error * fillarea(int x,int y,int target)
{
 stackitem  item;
 os_error * err;

 err=flex_alloc((flex_ptr)&stack,STACKLIM*sizeof(stackitem));
 if(!err)
 {
  stkptr=stack;
  stklt=stack+STACKLIM;

  item.x=x;
  item.y=y;
  item.llim=-1;
  item.rlim=-1;
  item.dir=3;

  do
  {
   err=fillline(&item,target);
   if(err) break;
   popstack(&item);
  } while((!(item.x==-1 && item.y==-1)));
  
  flex_free((flex_ptr)&stack);
 }

 return(err);
}


/*****************************************************************************/

#ifdef NEVER

static void getoutlinebig(int x,int y,int target)
{
 int i;
 int dir;
 int sx;
 int sy;
 int dx;
 int dy;

 dir=0;
 sx=x;
 sy=y;

 do
 {
  i=dir;
  do
  {
   switch(i & 0x7)
   {
    case 0:
           dx=-1;
           dy=1;
           break;

    case 1:
           dx=0;
           dy=1;
           break;

    case 2:
           dx=1;
           dy=1;
           break;

    case 3:
           dx=1;
           dy=0;
           break;

    case 4:
           dx=1;
           dy=-1;
           break;

    case 5:
           dx=0;
           dy=-1;
           break;

    case 6:
           dx=-1;
           dy=-1;
           break;

    case 7:
           dx=-1;
           dy=0;
           break;
   }

   if(pixelmxy(x+dx,y+dy)!=-1) {i=i & 0x7;break;}
   i++;

  }while(!(i>(dir+7)));

  if(i>(dir+7))
  {
   dx=dy=0;
  }

  x+=dx;
  y+=dy;

  addpoint(x*spddx,y*spddy);

  dir=(i+5) & 0x7;

 }while(!(x==sx && y==sy));
}


#endif


static os_error * getoutline(int x,int y,int target)
{
 int        i;
 int        dir;
 int        sx;
 int        sy;
 int        dx;
 int        dy;
 os_error * err;

 dir=0;
 sx=x;
 sy=y;
 err=NULL;

 do
 {
  i=dir;
  do
  {
   switch(i & 0x7)
   {
    case 0:
           dx=-1;
           dy=1;
           break;

    case 1:
           dx=0;
           dy=1;
           break;

    case 2:
           dx=1;
           dy=1;
           break;

    case 3:
           dx=1;
           dy=0;
           break;

    case 4:
           dx=1;
           dy=-1;
           break;

    case 5:
           dx=0;
           dy=-1;
           break;

    case 6:
           dx=-1;
           dy=-1;
           break;

    case 7:
   default:
           dx=-1;
           dy=0;
           break;
   }

   if(pixelmxy(x+dx,y+dy)==target) {i=i & 0x7;break;}
   i++;

  }while(!(i>(dir+7)));

  if(i>(dir+7))
  {
   dx=dy=0;
  }

  x+=dx;
  y+=dy;

  err=addpoint(x*spddx,y*spddy);
  if(err) break;

  dir=(i+5) & 0x7;

 }while(!(x==sx && y==sy));

 return(err);
}



#ifdef NEVER

static int pointcmp(const void * p1,const void * p2)
{
 if((((ipoint2*)p1)->y)==(((ipoint2*)p2)->y))
   return((((ipoint2*)p1)->x)-(((ipoint2*)p2)->x));
 else
   return((((ipoint2*)p1)->y)-(((ipoint2*)p2)->y));
}





/* fill area using outline */

static void fillareax(int target)
{
 int i;
 int xs;
 int ys;
 int x;
 int y;

 /* sort points by y then x */

 qsort(pointstore,npoints,sizeof(ipoint2),pointcmp);

 i=0;

 while(i<npoints)
 {
  y=pointstore[i].y;
  ys=y/(spddy);

  while((i<npoints) && (pointstore[i].y==y))
  {
   /* got one point */

   xs=pointstore[i].x/(spddx);

/*printf("xs=%d ys=%d target=%d mask=%d\n",xs,ys,target,pixelmxy(xs,ys));*/

   x=xs+1;
   while(pixelmxy(x,ys)==target)
   {
    setseenmask(x,ys);
    x++;
   }

   x=xs-1;
   while(pixelmxy(x,ys)==target)
   {
    setseenmask(x,ys);
    x--;
   }

   if(pixelmxy(xs,ys)==target) setseenmask(xs,ys);

   i++;
  }
 }
}


#endif

int spbackground=0;


// this is the one which produces a trace

static os_error * fitoutline(void)
{
 int x;
 int y;
 int target;
 int i;
 os_error * err;
 unsigned int c1;
 int          vindex;

 err=NULL;

 for(y=spy-1;y>=0;y--)
 {
  for(x=0;x<spx;x++)
  {
   if(!testseenmask(x,y))
   {
    target=pixelmxy(x,y);
    if(target!=-1)
    {
     clearpointstore();
     err=addpoint(x*spddx,y*spddy);
     if(err) break;

     err=getoutline(x,y,target);
     if(err) break;

     if(npoints>4)
     {
      c1=paltab[target];

      vecgetindex(vhandle,&vindex);

      veccolour(c1 & 0xFFFFFF00,c1 & 0xFFFFFF00,vhandle);
      vecstartpath(vhandle);

      if(!err) err=fitcurve(0,npoints);
      if(!err)
      {
       vecclosepath(vhandle);
       vectorupdate(vhandle,vindex);
      }
      if(bbc_inkey(0)==27) /* ESCAPE-hope nothing should follow this */
      {
       err=geterror(0);
       break;
      }
     }

     if(!err)
     {
      for(i=0;i<npoints;i++)
      {
       err=fillarea(pointstore[i].x/(spddx),pointstore[i].y/(spddy),target);
       if(err) break;
      }
     }
    }
   } 
   if(err) break;
  }
  if(err) break;
 }

 return(err);
}









// does proper trace

os_error * dofit(void)
{
 os_error * err;

 err=NULL;

 if(!framebase) err=geterror(ENOIMAGE);
 else
 if(framebase->frame[0].im[0].bpp>8) err=geterror(EBADBITS);

 if(!err)
 {
  hourglasson();

  vecscrap(&vhandle);
 
  err=initseenmask();

  if(!err)
  {
   err=initpointstore();

   if(!err)
   {
    err=vecopen(&vhandle);
    if(!err)
    {
     veclimits(0,0,vhandle);
     veclimits(spx*spddx,spy*spddy,vhandle);
     if(!err)
     {
      err=fitoutline();
      vecclose(vhandle);
     }
    }
    trashpointstore();
   }
   trashseenmask();
  }
  hourglassoff();

  if(err)
  {
   vecscrap(&vhandle);
  }

  refreshwindow(vectorhandle);
 }
 return(err);
}















#ifdef NEVER


static os_error * traceoutline(void)
{
 int        x;
 int        y;
 int        target;
 int        i;
 os_error * err;
 unsigned int c1;

 err=NULL;

 for(y=spy-1;y>=0;y--)
 {
  for(x=0;x<spx;x++)
  {
   if(!testseenmask(x,y))
   {
    target=pixelmxy(x,y);

    clearpointstore();

    err=addpoint(x*spddx,y*spddy);
    if(err) break;

    err=getoutline(x,y,target);
    if(err) break;

    if(npoints>1)
    {
     c1=paltab[target];

     veccolour(c1 & 0xFFFFFF00,c1 & 0xFFFFFF00,vhandle);
     vecstartpath(vhandle);

     err=vecmove(pointstore[0].x,pointstore[0].y,vhandle);

     if(!err)
     {
      for(i=1;i<npoints;i++)
      {
       err=vecdraw(pointstore[i].x,pointstore[i].y,vhandle);
       if(err) break;
      }
     }

     vecclosepath(vhandle);
    }

    if(!err)
    {
     for(i=0;i<npoints;i++)
     {
      err=fillarea(pointstore[i].x/(spddx),
                                     pointstore[i].y/(spddy),target);
      if(err) break;
     }
    }
   }
   if(err) break;
  }
  if(err) break;
 }

 
 return(err);
}




/* just joins the dots */

os_error * dotrace(void)
{
 os_error * err;

 err=NULL;

 if(spbpp>8) err=geterror(EBADBITS);
 if(!err)
 {
  vecscrap(&vhandle);

  err=initseenmask();
  if(!err)
  {
   err=initpointstore();
   if(!err)
   {
    err=vecopen(&vhandle);
    if(!err)
    {
     veclimits(spx*spddx,spy*spddy,vhandle);
     err=traceoutline();
     vecclose(vhandle);
    }
    trashpointstore();
   }
   trashseenmask();
  }

  if(err)
  {
   vecscrap(&vhandle);
  }
 }

 return(err);
}


#endif

